org.eclipse.viatra.query.runtime.matchers.psystem.basicdeferred

## Class Equality

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint
  - - org.eclipse.viatra.query.runtime.matchers.psystem.DeferredPConstraint
    - - org.eclipse.viatra.query.runtime.matchers.psystem.basicdeferred.Equality

- All Implemented Interfaces:
    PConstraint, PTraceable

      public class Equality
      extends DeferredPConstraint

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `PConstraint.CompareByMonotonousID`

  - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `pBody`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Equality(PBody pBody, PVariable who, PVariable withWhom)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `doReplaceVariable(PVariable obsolete, PVariable replacement)`
    `java.util.Set<PVariable>` | `getDeducedVariables()` The set of variables whose potential values can be enumerated (once all non-deduced variables have known values).
    `java.util.Map<java.util.Set<PVariable>,java.util.Set<PVariable>>` | `getFunctionalDependencies(IQueryMetaContext context)` A (preferably minimal) cover of known functional dependencies between variables.
    `PVariable` | `getWho()`
    `PVariable` | `getWithWhom()`
    `boolean` | `isMoot()` An equality is moot if it compares the a variable with itself.
    `boolean` | `isReadyAt(SubPlan plan, IQueryMetaContext context)`
    `protected java.lang.String` | `toStringRest()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `checkSanity, delete, getAffectedVariables, getMonotonousID, getPSystem, replaceVariable, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Equality

          public Equality(PBody pBody,
                          PVariable who,
                          PVariable withWhom)

  - ### Method Detail

    - #### isMoot

          public boolean isMoot()

      An equality is moot if it compares the a variable with itself.
      Returns:
        true, if the equality is moot

    - #### doReplaceVariable

          public void doReplaceVariable(PVariable obsolete,
                                        PVariable replacement)

      Specified by:
        `doReplaceVariable` in class `BasePConstraint`

    - #### toStringRest

          protected java.lang.String toStringRest()

      Specified by:
        `toStringRest` in class `BasePConstraint`

    - #### getWho

          public PVariable getWho()

    - #### getWithWhom

          public PVariable getWithWhom()

    - #### getDeducedVariables

          public java.util.Set<PVariable> getDeducedVariables()

      Description copied from interface: `PConstraint`
      The set of variables whose potential values can be enumerated (once all non-deduced variables have known values).

    - #### getFunctionalDependencies

          public java.util.Map<java.util.Set<PVariable>,java.util.Set<PVariable>> getFunctionalDependencies(IQueryMetaContext context)

      Description copied from interface: `PConstraint`
      A (preferably minimal) cover of known functional dependencies between variables.
      Specified by:
        `getFunctionalDependencies` in interface `PConstraint`
      Overrides:
        `getFunctionalDependencies` in class `BasePConstraint`
      Returns:
        non-trivial functional dependencies in the form of {variables} --> {variables}, where dependencies with the same lhs are unified.

    - #### isReadyAt

          public boolean isReadyAt(SubPlan plan,
                                   IQueryMetaContext context)

      Specified by:
        `isReadyAt` in class `DeferredPConstraint`